Attribute VB_Name = "modBase64"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld

Option Explicit

Global Const Base64CodeTafel = _
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

Public Function DataToBase64(strData As String) As String

'========================================================='
'= Funktion wandelt ASCII-Daten in Base64 kodierte Daten ='
'========================================================='
   
   Dim lngZhler As Long
   Dim lngCounter As Long
   
   Dim lngMax As Long
   
   Dim lngBuffer As Long
   Dim strBuffer As String
   
   lngMax = Len(strData)
   
   For lngZhler = 1 To lngMax
            
      strBuffer = strBuffer & _
         Format(DezToBin(Asc(Mid$(strData, lngZhler, 1))), "00000000")
      
      lngBuffer = Len(strBuffer)
         'Der Zwischenspeicher wird gefllt und die Lnge des gespeicherten String
         'vermerkt. Die Zwischenspeicherung der Textlnge erfolgt vor allem aus
         'Performance-Grnden, da dieser Wert mehrmals bentigt wird.
      
      If lngBuffer = 24 Or lngZhler = lngMax Then
         'Verarbeitung in Gruppen zu 24-Bit bzw. 8-Byte.
         
         If Not lngBuffer Mod 6 = 0 Then
            strBuffer = strBuffer & Mid$("000000", 1, 6 - lngBuffer Mod 6)
            lngBuffer = Len(strBuffer)
            
         End If
            'Die Binrbits die zuvor je Byte in 8er-Gruppen organisiert waren werden im
            'Nchsten Schritt in 6er-Gruppen neu sortiert. Damit diese Neuorganisation
            'auch stets aufgeht werden hier fehlende Bits (zum Sextett) durch angehngte
            '0-Bits geschlossen. Dies ist jedoch nicht immer erforderlich und auch stets
            'nur im letzten Durchgang der Codierung. Daher erfolgt zuvor eine Abfrage
            'mit Hilfe der Modulo-Funktion.
               
            
         For lngCounter = 1 To lngBuffer Step 6
            DataToBase64 = DataToBase64 & _
               Mid$(Base64CodeTafel, 1 + BinToDez(Mid$(strBuffer, lngCounter, 6)), 1)
               'Sind alle Bits bereit zur Verarbeitung und die Gruppen zu ganzen
               '6er-Verbnden geschlossen werden die Bits neu kodiert, indem die
               'Binrzahlenwerte wieder ins Dezimalsystem bertragen werden.
         Next
         
         strBuffer = ""
         
      End If
         
   Next
   
   If Not Len(strData) Mod 3 = 0 Then _
      DataToBase64 = DataToBase64 & Mid$("==", 1, 3 - Len(strData) Mod 3)
         'Wenn die Anzahl des Eingabebytes nicht durch drei teilbar ist werden die
         'fehlenden Bytes mit Fllbits ("0") geschlossen. Um bei der Dekodierung zu
         'erkennen welche Bytes vollstndig nachtrglich angefgt wurden werden diese
         'mit "=" kodiert. Da maximal zwei Bytes komplett mit Fllbits zu fllen sind
         'knnen nie mehr als zwei "==" kodiert werden.
   
End Function
Public Function Base64ToData(strBase64 As String) As String

'==========================================================='
'= Funktion wandelt Base64-Daten in gewhnlichen Daten um. ='
'==========================================================='

   Dim lngZhler As Long
   Dim lngCounter As Long
   Dim lngMax As Long
   
   Dim strBuffer As String

'== Unzulssige Zeichen ausfiltern ==='

   'Der Base64 Algorithmus gestattet lediglich die Verwendung der festgelegten
   '64 Zeichen zur Kodierung. Alle brigen Zeichen im Zeichen-Stream sind damit
   'nicht Bestandteil des Base64-Datenstreams und werden entfernt. Dies ermglicht
   'eine Formatierung der Daten per Leerzeichen oder hnliches, da diese bei der
   'Dekodierung ohnehin entfernt werden.
   
   lngMax = Len(strBase64)
   
   For lngZhler = 1 To lngMax
   
      strBuffer = Mid$(strBase64, lngZhler, 1)
      If InStr(Base64CodeTafel, strBuffer) = 0 Then
         strBase64 = Replace(strBase64, strBuffer, "")
         lngMax = Len(strBase64)
      End If
   
   Next
   
   strBuffer = ""
   
  
'== Base64 codierten Datenstream umwandeln ==='

   'Die "Entschlsselung" des Base64-Streams geschieht umgekehrt zur Kodierung.
   'Zunchst werden die einzelnen Buchstaben in Binrform berfhrt. Sodann
   'werden Gruppen zu 24 Bits in drei Zeichen  8 Bit bertragen. Diese werden
   'aus den sich hieraus ergebenden ASCII-Codes werden mit der Chr-Funktion
   'Buchstaben und Zeichen gebildet. Diese werden dem Ergebnisstring angehngt
   'und so fort bis der gesamte Datenstrom bertragen wurde.
   
   For lngZhler = 1 To lngMax
            
       strBuffer = strBuffer & _
         Format(DezToBin(InStr(Base64CodeTafel, _
            Mid$(strBase64, lngZhler, 1)) - 1), "000000")
              
       If (Len(strBuffer) = 24) Or (lngZhler = lngMax) Then
       
            For lngCounter = 1 To Len(strBuffer) Step 8
                  
               Base64ToData = Base64ToData & _
                  Chr(BinToDez(Mid$(strBuffer, lngCounter, 8)))
                     
            Next
            
            strBuffer = ""
       
       
       End If
            
   Next
   
End Function
Private Function DezToBin(ByVal dblDezimal As Double) As String

   '======================================================================'
   '= Funktion wandelt eine Zahl aus dem Dezimal- in das Binrsystem um. ='
   '======================================================================'

   DezToBin = ""

   Do
   
      DezToBin = dblDezimal Mod 2 & DezToBin
         
      dblDezimal = dblDezimal \ 2
         
   Loop Until dblDezimal < 1

End Function

Private Function BinToDez(ByVal strBinr As String) As Double

   '======================================================================'
   '= Funktion wandelt eine Zahl aus dem Binr- in das Dezimalsystem um. ='
   '======================================================================'
   
   Dim lngZhler As Long
   Dim lngMax As Long

   lngMax = Len(strBinr)

   For lngZhler = 0 To (lngMax - 1)
   
      BinToDez = BinToDez + CDbl(Mid$(strBinr, lngMax - (lngZhler), 1)) * (2 ^ lngZhler)
         
   Next

End Function
